import type { Router } from 'vue-router';
import { Dialog } from 'vant';
import { GetWxCode } from '@/api/auth';
/*
  Permission
*/

const whiteRoutes = ['/needAuth'];

function createPermissionGuard(router: Router) {
  router.beforeEach(async (to, from, next) => {
    if (whiteRoutes.includes(to.path)) {
      return next();
    }
    const reg = /(^|&)code=([^&]*)(&|$)/i;
    const result = window.location.search.substr(1).match(reg);
    if (result) {
      const code = decodeURI(result[2]);
      window.youngDanStorage.set('wxCOde', code);
      next();
    } else {
      next(false);
      Dialog.confirm({
        message: '是否确定授权？',
        title: '提示',
      }).then(async () => {
        await GetWxCode(to.path);
        // window.location.href = 'http://localhost:8888/?code=t_b_eDAzavIoX8c7uBwWD8Eb06um9xONMsG7nnkQ5Lg&state=#/';
      });
    }
  });
}

export default function setupRouterGuard(router: Router):void {
  createPermissionGuard(router);
}
