type StorageType = Storage

interface CreateStorageOptions {
  prefix?: string;
  safeTime?: number;
  once?: boolean
}

interface SetOptions {
  safeTime?: number;
  once?: boolean;
}

class CustomStorage {
  private prefix: string = '';

  private safeTime: number = 0;

  private once: boolean = false;

  private store: StorageType;

  constructor(storage: StorageType, config?: CreateStorageOptions) {
    this.store = storage;
    const { prefix, safeTime, once } = config || {};
    this.prefix = prefix || '';
    this.safeTime = safeTime || 0;
    this.once = once || false;
  }
  // setItem， 配置保质期和一次性存值 合并全局
  set(key: string, value: any, option?: SetOptions) {
    const {
      prefix, safeTime, once, store,
    } = this;
    const storeKey:string = `${prefix ? `${prefix}_` : ''}${key}`;
    store.set(storeKey, {
      time: new Date().getTime(),
      once: option?.once ? option.once : once || false,
      value: typeof value === 'object' ? JSON.stringify(value) : value,
    });
  };

  get(key) {
    const {
      prefix, safeTime, once, store,
    } = this;
    const storeKey:string = `${prefix ? `${prefix}_` : ''}${key}`;
    const 
  }
}

export const SessionStorage = new CustomStorage(sessionStorage, {
  prefix: '',
  safeTime: 1000 * 3600 * 72,
  once: false,
});
